/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.generationmodel;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import ru.entaxy.esb.platform.runtime.base.connecting.generator.Generated;
import ru.entaxy.platform.core.producer.api.EntaxyProducerService;
import ru.entaxy.platform.core.producer.api.ProducerResult;
import ru.entaxy.platform.core.producer.api.ProducerResult.CommandResult;

public abstract class AbstractTask {

    protected boolean isPrintOutput = false;

    protected List<Generated> oldResults = new LinkedList<>();

    protected GenerationModel generationModel;

    protected Generated generatedResult = null;

    protected AbstractTask mergeTo = null;

    protected boolean isFinal = true;

    public abstract String getInfo();

    public abstract boolean execute(
            ProducerResult currentResult, CommandResult currentCommand, EntaxyProducerService producerService,
            Map<String, Object> instructions) throws Exception;

    public GenerationModel getGenerationModel() {
        return generationModel;
    }

    public void setGenerationModel(GenerationModel generationModel) {
        this.generationModel = generationModel;
    }

    protected void printOutput(String message) {
        if (this.isPrintOutput)
            // OUTPUT TO CONSOLE
            System.out.println(message);
    }

    public boolean isPrintOutput() {
        return isPrintOutput;
    }

    public void setPrintOutput(boolean isPrintOutput) {
        this.isPrintOutput = isPrintOutput;
    }

    public Generated getGeneratedResult() {
        return generatedResult;
    }

    public void mergeTo(AbstractTask abstractTask) {
        this.mergeTo = abstractTask;
    }

    public boolean isToMerge() {
        return this.mergeTo != null;
    }

    public boolean isFinal() {
        return isFinal;
    }

    public void setFinal(boolean isFinal) {
        this.isFinal = isFinal;
    }

    public void updateGenerated(Generated generated) {
        oldResults.add(generatedResult);
        this.generatedResult = generated;
    }
}
